import { View } from "@tarojs/components"
import { FC, ReactNode } from "react"
import IconFont from "../iconfont"
import styles from './index.module.scss'

type IconfontName = Parameters<typeof IconFont>['0']['name']

interface PropsType {
  iconName: IconfontName
  title: string
  children?: ReactNode
  onClick?: Function
}
const IconCard: FC<PropsType> = (props) => {
  const { iconName, title, onClick } = props
  const handleClick = (event) => {
    onClick && onClick(event)
  }
  return (
    <View className={styles.iconCard} onClick={handleClick}>
      <IconFont name={iconName} size={72}></IconFont>
      <View className={styles['iconCard-name']}>{title}</View>
    </View>
  )
}
export default IconCard
