import { Image, Text, View } from "@tarojs/components";
import { memo, useEffect, useMemo, useRef, useState } from "react";
import classnames from "classnames";
import styles from './index.module.scss'

interface propsObj {
    receivingStatus: Number,
    onReceivingStatus?: (any, Number) => void
}
export default memo((props: propsObj) => {

    const {
        receivingStatus = 2,
        onReceivingStatus
    } = props



    return (
        <View className={styles.addressBox}>
            <View className={styles.topBox}>
                <View className={styles.cirle}>
                    <View className={classnames('iconfont', 'icon-dingwei', styles.dingwei)}></View>
                </View>
                <View className={styles.address}>广东省佛山市禅城区南庄镇吉利大道872巷7818号正门口</View>
                <View className={classnames('iconfont', 'icon-more', styles.icon_more)}></View>
            </View>
            <View className={styles.line}></View>
            <View className={styles.bottom}>
                <View className={styles.name}>谭先生</View>
                <View className={styles.phone}>13334726540</View>
                <View className={styles.reatBox}>
                    <View className={styles.updateBtn}>
                        <View className={styles.updateBtn_list}>
                            <View className={classnames(styles.updateBtn_item, receivingStatus == 1 && styles.updateBtn_item_select)} onClick={(e) => onReceivingStatus?.(e, 1)}>
                                自提
                            </View>
                            <View className={classnames(styles.updateBtn_item, receivingStatus == 2 && styles.updateBtn_item_select)} onClick={(e) => onReceivingStatus?.(e, 2)}>
                                物流
                            </View>
                        </View>
                        <View style={{ transform: receivingStatus == 1 ? 'translateX(0)' : 'translateX(100%)' }} className={classnames(styles.updateBtn_select)}></View>
                    </View>
                </View>
            </View>
        </View >
    )
})