import { View } from '@tarojs/components'
import React, { useCallback, memo, useEffect, useMemo, useRef, useState, ReactNode } from 'react'
import styles from "./index.module.scss"
import classnames from "classnames";
import Taro, { usePullDownRefresh } from '@tarojs/taro';
import AdvanceOrderState from './components/advanceOrderState'
import AddressDetailBox from './components/addressDetailBox'
import Remark from './components/remark'
import Popup from '@/components/popup'
import BottomBtns from '@/components/BottomBtns';
import BottomApply from './components/BottomApply';

export default () => {

    //页面下拉刷新
    usePullDownRefresh(() => {

    })



    //收货方法,1:自提，2物流
    const [receivingStatus, setReceivingStatus] = useState(2)
    //切换自提或者物流
    const onReceivingStatus = (e, value) => {
        e.stopPropagation()
        setReceivingStatus(value)
    }

    //订单信息文字数组
    const [orderMsg, setOrderMsg] = useState<any[]>([
        {
            leftTitle: '订单编号：',
            rightTitle: '2222',
            showBtn: true
        },
        {
            leftTitle: '创建时间：',
            rightTitle: '2222',
        },
        {
            leftTitle: '发货时间：',
            rightTitle: '2222',
        },
        {
            leftTitle: '业务员：',
            rightTitle: '2222',
        }
    ])

    //备注操作
    const [showDesc, setShowDesc] = useState(false)
    const getRemark = useCallback(async (e) => {

    }, [])

    //更多按钮查看操作
    const [showMore, setShowMore] = useState(false)

    return (
        <View className={styles.mainBox}>
            {/* <AdvanceOrderState orderInfo={a} onRefresh={refresh} /> */}
            <AddressDetailBox receivingStatus={receivingStatus} onReceivingStatus={(e, value) => onReceivingStatus(e, value)}></AddressDetailBox>
            <DefaultBox
                showMode={true}
                title={'客户信息'}
                modeName={'大货'}
            >
                <View className={styles.pussBox}>
                    <View className={styles.pussName}>JENNIEEEEE</View>
                    <View className={styles.pussPhone}>136******73</View>
                </View>
            </DefaultBox>
            <View className={styles.total}> 1 种面料，1 个颜色，共 4 M</View>
            <View className={styles.productBox}>
                <GoodsItem></GoodsItem>
                <View className={styles.flexMoney}>
                    <View className={styles.flexTotalBox}>
                        <View className={styles.totalFont}>合计金额</View>
                        <View className={classnames('iconfont', 'icon-tishi', styles.tishi)}></View>
                    </View>
                    <View className={styles.shoudPay}>12,332.00</View>
                </View>
                <View className={styles.flexMoney}>
                    <View className={styles.flexTotalBox}>
                        <View className={styles.totalFont}>实付金额</View>
                        <View className={classnames('iconfont', 'icon-tishi', styles.tishi)}></View>
                    </View>
                    <View className={styles.shoudPay}>12,332.00</View>
                </View>
                <View className={styles.flexMoney}>
                    <View className={styles.flexTotalBox}>
                        <View className={styles.totalFont}>待付金额</View>
                        <View className={classnames('iconfont', 'icon-tishi', styles.tishi)}></View>
                    </View>
                    <View className={styles.shoudPay}>12,332.00</View>
                </View>
            </View>
            <DefaultBox title={'订单信息'}>
                {
                    orderMsg.map((item, index) => {
                        return (
                            <View className={styles.detailBox} key={index}>
                                <View className={styles.detailFont}>
                                    {item.leftTitle}
                                </View>
                                <View className={styles.detailRightFlex}>
                                    <View className={styles.detailRight}>{item.rightTitle}</View>
                                    {item.showBtn && <View className={styles.detailBtn}>复制</View>}
                                </View>

                            </View>
                        )
                    })
                }

            </DefaultBox>
            <DefaultBox title={'备注信息'} showMode={true} modeName={`${'填写/修改备注'} >`} clickNode={() => setShowDesc(true)}>
                <View className={styles.remarkFont}>尚未备注信息</View>
            </DefaultBox>
            <Popup show={showDesc} showTitle={false} onClose={() => setShowDesc(false)}>
                <Remark onSave={(e) => getRemark(e)} defaultValue={''} />
            </Popup>
            <View className={styles.safeBottom}></View>
            <View className={styles.bottomBox}>
                {
                    !showMore && <View className={styles.moreFont} onClick={() => setShowMore(true)}>更多</View>
                }
                {
                    showMore && <View className={styles.moreFont} onClick={() => setShowMore(false)}>关闭</View>
                }
                {
                    showMore && <View className={styles.posssBox}>
                        <BottomApply ></BottomApply>
                    </View>
                }
                <BottomBtns></BottomBtns>
            </View>
        </View>
    )
}



//卡片盒子元素
interface Obs {
    title?: string,
    modeName?: string,
    showMode?: boolean,
    children?: ReactNode,
    clickNode?: () => void
}

const DefaultBox = memo((props: Obs) => {
    const {
        title = '标题',
        modeName = '大货',
        showMode = false,
        children,
        clickNode
    } = props

    return (
        <View className={styles.defaltBox}>
            <View className={styles.titleBox}>
                <View className={styles.title}>{title}</View>
                {
                    showMode && <View className={styles.modeName} onClick={() => clickNode?.()}>{modeName}</View>
                }
            </View>
            <View className={styles.modeLine}></View>
            {children}
        </View>
    )
})


//产品商品元素
interface PropGoods {
    item?: {
        code?: string | number
    }
}
const GoodsItem = memo((porps: PropGoods) => {
    const { item } = porps
    return (
        <View className={styles.goodsBox}>
            <View className={styles.goodsProduct}>0681# 26S全棉平纹</View>
            <View className={styles.goodsLine}></View>
            <View className={styles.itemGoods}>
                <View className={styles.itemPic}></View>
                <View className={styles.itemRight}>
                    <View className={styles.item_right_top}>
                        <View className={styles.itemName}>001# 环保黑</View>
                        <View className={styles.itemNums}>x1m</View>
                    </View>
                    <View className={styles.item_right_Bottom}>
                        <View className={styles.itemMoney}>¥340/m</View>
                        <View className={styles.itemMoneyOne}>¥2,332.00</View>
                    </View>
                </View>
            </View>
        </View>
    )
})

